#! /usr/bin/python
# encoding: utf-8

#*    dsgui - a graphical user interface for Datove schranky
#*    Copyright (C) 2009-2010  CZ.NIC, z.s.p.o. (http://www.nic.cz)
#*
#*    This library is free software; you can redistribute it and/or
#*    modify it under the terms of the GNU Library General Public
#*    License as published by the Free Software Foundation; either
#*    version 2 of the License, or (at your option) any later version.
#*
#*    This library is distributed in the hope that it will be useful,
#*    but WITHOUT ANY WARRANTY; without even the implied warranty of
#*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#*    Library General Public License for more details.
#*
#*    You should have received a copy of the GNU Library General Public
#*    License along with this library; if not, write to the Free
#*    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA


import sys
import glob
import os
if sys.platform == "darwin":
  # use setuptools on Mac
  from setuptools import setup
else:
  # use distutils on anything else
  from distutils.core import setup


# the setup itself
# dslib subpackages
dslib_dir = "dslib"
pkgdirs = ["dsdb","converters","sudsds","pkcs7","pyasn1","properties","certs"]
dslib_subpackages = []
for pkgdir in pkgdirs:
  for name,dirs,files in os.walk(os.path.join(dslib_dir, pkgdir)): #, followlinks=True):
    if os.path.exists(os.path.join(name,"__init__.py")):
      if not "suds-svn-work" in name:
        dslib_subpackages.append(name.replace("/","."))
print >> sys.stderr, dslib_subpackages


data = dict(
  name = 'dsgui',
  version = '1.0-beta1',
  description = "dsgui is a free graphical interface for 'Datove schranky'",
  author = "CZ.NIC Labs",
  author_email = "datove-schranky@labs.nic.cz",
  url = "http://labs.nic.cz/datove-schranky/",
  license = "GNU LGPL",
  platforms = ["Unix", "Windows","MacOS X"],
  long_description = "dsgui is a GUI for dslib - a free library for 'Datove schranky'",
  
  packages=['dsgui']+dslib_subpackages,
  package_dir = {'dsgui': './'},
  data_files = [('dslib', ['dslib/README', 'dslib/LICENSE']),
                ('doc', ['doc/index.html']),
                ('dslib/pyasn1', ['dslib/pyasn1/LICENSE']),
                ('dslib/trusted_certificates', glob.glob('dslib/trusted_certificates/*.pem')),
                ('icons',glob.glob('icons/*.png')+glob.glob('icons/*.svg')),
                ],
  )

if sys.platform == "darwin":
  data.update(
    options={'py2app': {'argv_emulation': True}},
    app=['dsgui.py'],
    setup_requires=['py2app'],
    )

set = setup(**data)

